<?php
/*
Plugin Name: XML Video Sitemap for Google
Plugin URI: http://www.labnol.org/
Description: This plugin will generate a XML Video Sitemap for your WordPress blog using all the YouTube videos that you may have embedded in your blog posts. 
Author: Amit Agarwal
Version: 1.0
Author URI: http://www.labnol.org/about/
*/


add_action ('admin_menu', 'video_sitemap_generate_page');

function video_sitemap_generate_page () {
	if (function_exists ('add_submenu_page'))
    	add_submenu_page ('tools.php', __('Video Sitemap'), __('Video Sitemap'),
        	'manage_options', 'video-sitemap-generate-page', 'video_sitemap_generate');
}

function video_sitemap_generate () {

	if ($_POST ['submit']) {
		video_sitemap_loop ();
?>

    <div class="wrap">
    <div style="float:right; margin:10px">
      <iframe src="http://www.facebook.com/plugins/likebox.php?id=5791561181&amp;width=250&amp;height=260&amp;connections=8&amp;stream=false&amp;header=false" scrolling="no" frameborder="0" allowTransparency="true" style="border:none; overflow:hidden; width:250px; height:260px"></iframe>
    </div>
    <h2>XML Sitemap for Videos</h2>   
<?php $sitemapurl = get_bloginfo('url') . "/video-sitemap.xml"; ?>
	<p>The XML Sitemap was generated successfully. Please open the <a target="_blank" href="<?php echo $sitemapurl; ?>">Sitemap file</a> in your favorite web browser to confirm that there are no errors.</p>
    <p>You can submit your Video XML Sitemap through <a href="http://www.google.com/webmasters/tools/" target="_blank">Webmaster Tools</a> or you can directly <a target="_blank" href="http://www.google.com/webmasters/sitemaps/ping?sitemap=<?php echo $sitemapurl; ?>">ping Google</a>.</p>
    <h3>Suggestions?</h3>
        <p>Please email your suggestions to Amit Agarwal at amit@labnol.org. You can also connect with <a href="http://www.labnol.org/" target="_blank">Digital Inspiration</a> on <a href="http://twitter.com/labnol" target="_blank">Twitter</a> and <a href="http://www.facebook.com/digital.inspiration" target="_blank">Facebook</a>. </p>
    
<?php } else { ?>

	<div class="wrap">
  		<h2>XML Sitemap for Videos</h2>
		<p>Sitemaps are a way to tell Google and other search engines about web pages, images and video content on your site that they may otherwise not discover. </p>

		<h3>Create Video Sitemap</h3>

		<form id="options_form" method="post" action="">
            <input type="checkbox" id="sboption" name="time" value="1" />
			<label for="sboption">Include video length? (Not recommended for sites will large number of videos)</label>
            <div class="submit">
            	<input type="submit" name="submit" id="sb_submit" value="Generate Video Sitemap" />
            </div>
		</form>
		<p>You can click the button above to generate a Video Sitemap for your website. Once you have created your Sitemap, you should submit it to Google using Webmaster Tools. </p>

        <h3>Suggestions?</h3>
        <p>Please email your suggestions to Amit Agarwal at amit@labnol.org.</p><p> You can also connect with <a href="http://www.labnol.org/" target="_blank">Digital Inspiration</a> on <a href="http://twitter.com/labnol" target="_blank">Twitter</a> and <a href="http://www.facebook.com/digital.inspiration" target="_blank">Facebook</a>. </p>
</div>

<?php	}
}

function video_sitemap_loop () {
	global $wpdb;

	$posts = $wpdb->get_results ("SELECT id, post_title, post_content, post_date_gmt, guid, post_excerpt 
							FROM $wpdb->posts 
							WHERE post_status = 'publish' 
							AND post_type = 'post'
							AND post_content LIKE '%youtube.com%'
							ORDER BY post_date DESC");

	if (empty ($posts)) {
		return false;

	} else {

		$xml  = '<?xml version="1.0" encoding="UTF-8"?>' . "\n";                
		$xml .= '<?xml-stylesheet type="text/xsl" href="' . get_bloginfo('wpurl') . '/wp-content/plugins/xml-sitemaps-for-videos/video-sitemap.xsl"?>' . "\n" ;
        $xml .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9" xmlns:video="http://www.google.com/schemas/sitemap-video/1.1">' . "\n";
	
		foreach ($posts as $post) {
			if (preg_match_all ("(<embed[^>]*src=['\"]http:\/\/www.youtube.com\/v\/([a-zA-Z0-9\-_]*)|youtube.com\/watch\?v=([a-zA-Z0-9\-_]*))", 
				$post->post_content, $matches, PREG_SET_ORDER)) {

					$excerpt = ($post->post_excerpt != "") ? $post->post_excerpt : $post->post_title ; 
					$permalink = get_permalink($post->id); 

					foreach ($matches as $match) {
						$id = $match [1];
						if ($id == '') $id = $match [2];
						if ($id == '') $id = $match [3];
						
					$xml .= "\n <url>\n";
					$xml .= " <loc>$permalink</loc>\n";
					$xml .= " <video:video>\n";
					$xml .= "  <video:player_loc allow_embed=\"yes\" autoplay=\"autoplay=1\">http://www.youtube.com/v/$id</video:player_loc>\n";
					$xml .= "  <video:thumbnail_loc>http://i.ytimg.com/vi/$id/0.jpg</video:thumbnail_loc>\n";
					$xml .= "  <video:title>" . htmlspecialchars($post->post_title) . "</video:title>\n";
					$xml .= "  <video:description>" . htmlspecialchars($excerpt) . "</video:description>\n";
	
                    if ($_POST['time'] == 1) {  
						$duration = youtube_duration ($id);
						if ($duration != 0)
 							$xml .= "  <video:duration>".youtube_duration ($id)."</video:duration>\n";
					}

					$xml .= "  <video:publication_date>".date (DATE_W3C, strtotime ($post->post_date_gmt))."</video:publication_date>\n";
	
					$posttags = get_the_tags($post->id); if ($posttags) { 
					foreach ($posttags as $tag) {
						$xml .= "   <video:tag>$tag->name</video:tag>\n";
						}
					}	

					$postcats = get_the_category($post->id); if ($postcats) { 
					foreach ($postcats as $category) {
						$xml .= "   <video:category>$category->name</video:category>\n";
						}
					}		

					$xml .= " </video:video>\n </url>";
				}
			}
		}

		$xml .= "\n</urlset>";
	}

	$video_sitemap_url = $_SERVER["DOCUMENT_ROOT"] . '/video-sitemap.xml';
	file_put_contents ($video_sitemap_url, $xml);

}

# given a video id, get the duration.
# might give this a delay to avoid running into issues with YouTube.
function youtube_duration ($id) {
	try {
		$ch = curl_init ();
		curl_setopt ($ch, CURLOPT_URL, "http://gdata.youtube.com/feeds/api/videos/$id");
		curl_setopt ($ch, CURLOPT_RETURNTRANSFER, 1);
		$data = curl_exec ($ch);
		curl_close ($ch);

		preg_match ("/duration=['\"]([0-9]*)['\"]/", $data, $match);
		return $match [1];

	} catch (Exception $e) {
		# returning 0 if the YouTube API fails for some reason.
		return '0';
	}
}
?>
